type

    StructureTable=record
        ST_PATCH                   : string[31];
        ST_PARENT                  : dword;
        ST_SIZE_COUNT              : dword;
        ST_PERMISSION              : word;
        ST_DTIMEW                  : dword;       // CREAT TIME FOR DIRECTORIES
        ST_DTIMER                  : dword;       // OR STATE INFO FOR DIRECTORIES
    end;

    mr_type=record
        MR_BLOCK_COUNT             :word;
        MR_FREE_BLOCK_COUNT        :word;
        MR_CLAST_SIZE              :word;
        MR_LAST_WRITE              :word;
        MR_LAST_CHECK              :word;
        MR_RESERVEDA               :word;
        MR_RESERVEDB               :word;
        MR_RESERVEDC               :word;
        MR_VERSION                 :byte;
        MR_KERNEL_DEF              :byte;
        MR_SIGNATURE               :word;
        MR_RESERV                  :array[0..489] of byte;
    end;

    ct_type=record
          CT_FREE_COUNT            : word;
          CT_DETERMIN              : array [0..767] of word;      //1024  
          CT_NCLASTER              : array [0..1023] of word;     //- ,  
    end;

   St_type=record
      ST : array [0..1023] of StructureTable;
   end;

   CLASTER1024=record
               DATA:array[0..255]of DWORD;  //   1024 
   end;

var

        A:mr_type;
        B:St_type;
        C:ct_type;
        r:dword;
        claster:claster1024;

        FIn:text;
        FOu1:file of mr_type;
        FOu2:file of st_type;
        FOu3:file of ct_type;
        FOu4:file of claster1024;

begin

       Assign(FOu1,'b.img');
       Rewrite(FOu1);
       Assign(FOu2,'c.img');
       Rewrite(FOu2);
       Assign(FOu3,'d.img');
       Rewrite(FOu3);

// A EDITION :
       A.MR_BLOCK_COUNT:=1;
       A.MR_FREE_BLOCK_COUNT:=0;
       A.MR_CLAST_SIZE:=1024;
       A.MR_VERSION:=3;
       A.MR_KERNEL_DEF:=1;
       A.MR_SIGNATURE:=$7eea;

       B.ST[0].ST_PATCH:='sys';
       B.ST[0].ST_PARENT:=0;
       B.ST[0].ST_SIZE_COUNT:=0;
       B.ST[0].ST_DTIMER:=1;

       B.ST[1].ST_PATCH:='kernel.bin';
       B.ST[1].ST_PARENT:=1;
       B.ST[1].ST_SIZE_COUNT:=64;

       B.ST[2].ST_PATCH:='srv';
       B.ST[2].ST_PARENT:=0;
       B.ST[2].ST_SIZE_COUNT:=0;
       B.ST[2].ST_DTIMER:=2;

       B.ST[3].ST_PATCH:='servers.auto';
       B.ST[3].ST_PARENT:=2;
       B.ST[3].ST_SIZE_COUNT:=1;

       C.CT_FREE_COUNT:=$FFFF-67;                // 67     
       C.CT_DETERMIN[0]:=$0010;                  // 3 word = 4  
       C.CT_DETERMIN[1]:=$0200;                  // .. 1,2,3  4  ()  = $001 - $004
       C.CT_DETERMIN[2]:=$3004;
       C.CT_NCLASTER[0]:=1;                     //  -   () - 1)sys
       C.CT_NCLASTER[1]:=64;                    // 2)kernel.bin
       C.CT_NCLASTER[2]:=1;                     // 3)srv
       C.CT_NCLASTER[3]:=1;                     // 4)servers.auto

// SAVE FILE :
        Write(FOu1,A);
        Write(FOu2,B);
        Write(FOu3,C);

        writeln('STFS was created.');
        writeln;
        writeln('Size of STFS MainRecords     = ',sizeof(a),' bytes');
        writeln('Size of Structures determain = ',sizeof(b),' bytes');
        writeln('Size of clasters table       = ',sizeof(c),' bytes');
        writeln('--------------------------------------------------------------');
        Writeln(' TOTAL                       = ',((sizeof(a)+sizeof(b)+sizeof(c))/1024):4:3,' Kbytes');

       Close(FOu1);
       Close(FOu2);
       Close(FOu3);

       // Ok...  :

       //   sys
       Assign(FOu4,'e.img');
       Rewrite(FOu4);
       claster.data[0]:=$00000002; //id  kernel.bin
       claster.data[1]:=$00000000; // 
       Write(FOu4,claster);
       close(Fou4);

       //   srv
       Assign(FOu4,'f.img');
       Rewrite(FOu4);
       claster.data[0]:=$00000004; //id  servers.auto
       claster.data[1]:=$00000000; // 
       Write(FOu4,claster);
       close(Fou4);

end.