unit INT_21h;

{$IFDEF MSWINDOWS}
  {$ASMMODE INTEL}
{$ENDIF}

{$MODE OBJFPC} //required for Result variable
{$MACRO ON}

//     1)Input-Console 80x25
//     2)File service

interface


procedure _Int_21h;
//   Buf_flag	   -> $200000  (Byte);
//   Buf_adr	   -> $200001  (Pointer);
//   Curr_position -> $50 (word);                    пїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅ пїЅпїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅпїЅпїЅпїЅпїЅ
//   Text_attr     -> $52 (byte);                    пїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅ пїЅпїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅпїЅпїЅпїЅпїЅ



//   StructureTable -> $5F0000 (to $600000)          пїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅ пїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅ




implementation

type
  LOW_REGISTERS=record
    _EAX,_EBX,_ECX,_EDX:LongWord;
    _AX,_BX,_CX,_DX,_DS:Word;
    _AL,_AH,_BL,_BH,_CL,_CH,_DL,_DH:byte;
  end;

var
  REG:low_Registers;

const
	memory_block_size=1024;	//Размер блока памяти в байтах

type
  PChar=^Char;

const
  r:string[32]=#0#1#9#1#0'Init text area located in '#0;
  mes_1:String[40]='Hello world'#0;

  Init_info_1:String[40]='Memory manager loaded '#0;
  Init_info_2:String[40]='                       Total Memory : '#0;
  Init_info_3:String[40]='                       Start Point  : '#0;
  Init_info_4:String[40]='                       Free Pages   : '#0;
  Init_bytes:String[7]=' bytes'#0;

  const_str_ExStr:String[25]='simple short string'#0;



var init_flag:byte;
    zr:array [1..200] of char;

procedure Write_UINT(A:longword); forward;


{$I sdt_lib.pas}		// Функции памяти
{$I stfsata.pas}


procedure Write_CHR(A:byte);    var c_p:word;
begin
     c_p:=0;
     if A=$0D then
          begin
                  asm   
                          mov ax,word ptr [50h]
                          mov Reg._ax,ax
                  end;
                  Reg._ax:=80+Reg._ax;{str_length*((Reg._ax div str_length)+1);}
                  asm
                          mov ax,Reg._ax
                          mov word ptr [50h],ax
                  end
          end
     else if  A=$0A then
          begin
                  asm   
                          mov ax,word ptr [50h]
                          mov Reg._ax,ax
                  end;
                  Reg._ax:=80*(Reg._ax div 80 + 1);{str_length*((Reg._ax div str_length)+1);}
                  asm
                          mov ax,Reg._ax
                          mov word ptr [50h],ax
                  end
          end
     else
     begin
     asm                                                                
          mov ebx,0b8000h
          xor eax,eax
          mov ax,word ptr [50h]
          mov c_p,ax
          add bx,ax
          add bx,ax
          mov al,byte ptr a
          mov [ebx],al
          mov al,byte ptr [52h]
          mov byte ptr [ebx+1],al
          add word ptr [50h],1
     end;
//asm db $eb,$fe; end;
     end;
     if  c_p>(80*25) then
     asm
              mov ebx,0b8000h
              xor eax,eax
              add ebx,160
              mov ecx,80*24/2

          @@dword:
              mov  eax,dword ptr [ebx]
              mov  dword ptr [ebx-160],eax
              add  ebx,4
              dec  ecx
              jnz  @@dword

              sub  word ptr [50h],80
     end;
end;

procedure Write_STR(A:Pointer);		
var
  c:byte;
begin
  repeat
    asm
      mov  eax,A
      mov  bl,byte ptr [eax];
      mov  c,bl
      inc  A
    end;
    if c<>$0 then Write_CHR(c);
  until c=$0;
end;

procedure Write_UINT(A:longword);			// Вывод беззнакого числа
var
	i:longword; razrjad:byte;
        dig:array[1..20]of Byte;
begin
	i:=a;
	razrjad:=1;
	if i=0 then Write_CHR(ord('0')) else
 	begin
	while i<>0 do
	begin
		dig[razrjad]:=(byte((i mod 10)))+byte(ord('0'));
		i:=i div 10;
		inc(razrjad);
	end;
	for i:=razrjad-1 downto 1 do Write_CHR(dig[i]);
	end;
end;

Procedure Write_DINT(a:longword);			// вывод числа со знаком
var i:longword;
begin
	i:=a;
	if i>($fff7fffff div 2) then begin Write_CHR(ord('-')); i:=not (i-1); end;
	Write_UINT(i);
end;

procedure PutHexD(digit:byte);
begin
	case digit of
	  0: Write_CHR(ord('0'));
 	  1: Write_CHR(ord('1'));
          2: Write_CHR(ord('2'));
          3: Write_CHR(ord('3'));
          4: Write_CHR(ord('4'));
	  5: Write_CHR(ord('5'));
	  6: Write_CHR(ord('6'));
 	  7: Write_CHR(ord('7'));
          8: Write_CHR(ord('8'));
          9: Write_CHR(ord('9'));
         10: Write_CHR(ord('A'));
	 11: Write_CHR(ord('B'));
         12: Write_CHR(ord('C'));
 	 13: Write_CHR(ord('D'));
         14: Write_CHR(ord('E'));
         15: Write_CHR(ord('F'));
        end;
end;

procedure PutDec(Value:longword);
const
	i:word=0;
var
	b1:byte;
	b:array[0..30]of word;
	nb:word;
	b2:word;
begin
	b2:=value;
	while true do
	begin
		b1:=b2 mod 10;
		b[i]:=b1;
		nb:=b2 div 10;
		if (nb=0) then break;
		inc(i);
		b2:=nb;
	end;
	for nb:=i+1 downto 0 do PutHexD(b[nb-1]);
end;

procedure PutHex(value:byte);
var
	lb,rb:byte;
begin
	lb:=value shr 4;
	rb:=value and $f;
	PutHexD(lb);
	PutHexD(rb);
end;

procedure PutHexI(value:longword);
var b:byte;
begin
	b:=(value and $ff000000)shr 24; PutHex(b);
	b:=(value and $00ff0000)shr 16; PutHex(b);
	b:=(value and $0000ff00)shr 8;  PutHex(b);
	b:=(value and $000000ff); 	PutHex(b);
end;

procedure Write_Ln;
begin
	Write_CHR($0A);
end;

procedure Assign_File(Way:longint);
var
sway: array [0..255] of char; i:byte; k:longint;
begin
  {
  i:=0;
  sway[i]:='/';
  while (ord(sway[i])<>$00) and (i<>255) do  // Get way
    asm
      mov  eax,Way
      add  eax,i
      mov  al,byte ptr [eax]
      mov  ebx,sway
      add  ebx,i
      mov  byte ptr [ebx],al
      inc  i
    end;
  //пїЅпїЅпїЅпїЅпїЅпїЅ, пїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅпїЅпїЅпїЅпїЅ пїЅпїЅпїЅпїЅ:
  //    LoadStructureTable;
  }
end;


{old string-man, do not include} {I hSystemStrings.inc.pas}
{old string-constant file, do not include} {I rcs.inc.pas} 


{resource string consts mustdie}{
procedure InitResourceStringConsts;
begin
  PrepareResourceConsts;
  WriteHStringLn(_const_rcs_OnInitRestrings);
end; }

{procedure testMemoryMan;
  procedure pms;
  begin
    PrintMemoryState;
  end;
var
  a1,a2:TAddress;
begin
  pms;
  a1:=GetMemory(3000);
  WriteChar('='); Writechar('='); WriteHStringLN(IntToShortStr(a1));
  if a1=const_getmemory_err then
    WriteHStringLN('error: can not get memory'#0);
  pms;
  a2:=GetMemory(2000);
  WriteChar('='); Writechar('='); WriteHStringLN(IntToShortStr(a2));
  pms;
  FreeMemory(a1);
  pms;
  if not FreeMemory(a2) then
    WriteHStringLn('error: can nto free memory'#0);
  pms;
end;}


Procedure Write_CString(c:Pointer);
var i,j:byte; p,rd,g:pointer;
begin
  rd:=@r;
  g:=c;
  asm
        mov eax,dword ptr [$20001]
	add eax,g
	sub eax,rd
	mov p,eax
  end;
  Write_Str(p);
end;


{$I stringman.pas}
{$I smconsole.pas}

  {tests hSystemStrings.inc.pas unit}
procedure testStringMan;
const
  mes_ppp:string='...'#0;
  mes_testing='testing stringman...'#0;
var
  n,p:Pchar;
  k:pointer;
  z:longint;

  shstr:TShortString;
  s2:TShortString;

  primer_massiva:array[1..100]of byte;
  zb:byte;
  
  arr:TFixedShortStrList;
begin
  //Write_CString(@mes_1);
  //sstr_newLn;

  //sstr_EchoLn(@mes_testing+' ');  

  for z:=ord('A') to ord('z') do primer_massiva[z-ord('A')]:=z;
  For z:=ord('A') to ord('z') do Write_CHR(primer_massiva[z-ord('A')]);

  sstr_NewLn;

  shstr:=sstr_create(@const_str_ExStr);

  //shstr:=shstr+@mes_ppp;
  sstr_AddPcharConst(shstr,@mes_ppp);
 
  sstr_echoLn(shstr+' '+@mes_1+'.'); //works
  sstr_delete(shstr,2,3);
  sstr_echoLn(shstr+' '+'/'+'/'+IntToShortStr(shstr.len));
  
  sstr_split(shstr,' ',arr);
  z:=0;
  while z<arr.len do 
  begin
    sstr_EchoLn(tfssl_get(arr,z));
    inc(z);
  end;

  smvu_init;
  smvu_clear;
  {
  z:=1;
  while z<=100 do
  begin
    smvu_write(shstr+' '+IntToShortStr(z)+';');
    inc(z);
  end;
  //smvu_scroll;
  }
  
  {
  arr.addItem(shstr);
  WriteChar('#');
  //arr.addItem('*'+sstr_create(@mes_1)+'*');
  arr.foreach(@sstr_echoLn);
  WriteChar('#'); WriteChar('#');WriteChar('#');
  }
  

  {Write_ln;
  Write_CString(@mes_2);
  Write_ln;
  for z:=0 to 10 do
   begin
	 Write_UINT(z);
	 Write_Chr(ord(' '));
   end;
  Write_ln;
  for z:=-10 to 10 do
  begin
	Write_DINT(z);
        Write_Chr(ord(' '));
  end;
  Write_ln;
  For z:=1 to 32 do
  begin 
	PutHex(z);
        Write_Chr(ord(' '));
  end;}
end;

function runConsole:boolean;
const
  s_singCe:string='starting console...'#0;
var
  convar:TsmConsoleProcs;
begin
  convar.DoNextString:=nil;
  convar.DoExec:=nil;
  sstr_echoPchLn(@s_singCe);
  smc_InitAndRun(convar);
end;

{$define hall}
{$I coolmm.pas}
{$I hmutex.inc.pas}
{$I task_key.inc.pas}
{$undef hall}


procedure init_buffer;
var p:pointer; se:byte;
    memsize:longint;
begin

// Инициализация текстового буфера

  p:=Pointer($20100);
  se:=0;
  while se<>5 do
  begin
    if Char(p^) in [#0,#1,#9] then
    case se of
       4 : if Char(p^)=#0 then inc(se);
       3 : if Char(p^)=#1 then inc(se) else se:=0;
       2 : if Char(p^)=#9 then inc(se) else se:=0;
       1 : if Char(p^)=#1 then inc(se) else se:=0;
       0 : if Char(p^)=#0 then inc(se) else se:=0;
       5 : break;
    end
    else se:=0;
    inc(p);
  end;
  asm
    mov byte ptr [$20000],200
    mov eax,p
    sub eax,5
    mov dword ptr [$20001],eax
  end;
  Write_Str(p);
  Write_Chr(ord('['));
  PutHexI(LongInt(p-5));
  Write_Chr(ord('h'));
  Write_Chr(ord(']'));
  Write_ln;

// Инициализация менеджера памяти и задач CoolMM

  asm
	mov eax,dword ptr [$100000]
	mov memsize,eax
  end;

  InitializeMM(memory_block_size,memsize*16*1024*1024-$600000);

 // PrintMemoryState; <- Теперь работает

 //InitTaskSwitcher(GetKeyTaskProcsPack);

end;

procedure _Int_21h;

begin
  asm
    db $0,$ff,$0f,$fa,$f0,$af,$aa;
  end;

  asm
    mov  REG._AH,ah
    mov  REG._DL,dl
    mov  REG._EDX,edx
  end;

  asm
      mov al,byte ptr [$20000];
      mov init_flag,al
  end;
  if init_flag<>200 then init_buffer;

  case REG._AH of
    002:   Write_CHR(REG._DL);
    006:   Write_CHR(REG._DL);
    $3D: Write_STR(Pointer(REG._EDX));
    $E0: Assign_File(REG._EDX);
    $f1: begin testStringMan; runConsole; end;
    $f2: {InitializeCoolMM};
    $f3: {runConsole};
  end;

  asm
    iretd
  end;
end;

end.
