
  _unknown_error	 = 00h
  _function_unavailable  = 01h
  _invalid_value	 = 02h
  _invalid_selector	 = 03h
  _invalid_address	 = 04h
  _out_of_resources	 = 05h
  _out_of_memory	 = 06h
  _string_too_long	 = 07h
  _invalid_path 	 = 10h
  _file_not_found	 = 11h
  _invalid_access_mode	 = 12h
  _directory_not_empty	 = 13h
  _invalid_name 	 = 14h
  _write_error		 = 15h
  _invalid_program	 = 16h

int_ok: 				; universal return procedure
	popa				;  for system services
	pop	es ds
	and	byte [esp+8],not 1	; clear CF
	iret

int_error:				; universal return error procedure
	popa				;  for system services
	pop	es ds
	mov	eax,[cs:error_code]
	or	byte [esp+8],1		; set CF
	iret

error_code dd 0
